# coding: utf-8

"""
    VMware Aria Automation Assembler IaaS API

    IAAS API is a RESTful service, which allows users to execute provisioning related UI actions via an API.  This page describes the RESTful APIs for IAAS API. The APIs facilitate CRUD operations on the various resources and entities used throughout VMware Aria Automation Assembler(Cloud Accounts, Cloud zones, Computes, Mappings, etc.) and allows operations on them (creating a cloud account, patching a machine, creating image progile, etc.).  The APIs that list collections of resources also support OData like implementation. Below query params can be used across different IAAS API endpoints  Example: 1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.     ```/iaas/api/cloud-accounts?$orderby=name%20desc```  2. `$top` -  number of records you want to get.     ```/iaas/api/cloud-accounts?$top=20```  3. `$skip` -  number of records you want to skip.      ```/iaas/api/cloud-accounts?$skip=10```  4. `$select` - select a subset of properties to include in the response.        ```/project-service/api/projects?$top=10&$skip=2```  5. `$filter` -  filter the results by a specified predicate expression. Operators: eq, ne, and, or.\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'ABC*'``` - name starts with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC*'``` - name contains 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC'``` - name ends with 'ABC'\\     /iaas/api/projects and /iaas/api/deployments support different format for partial match:\\     ```/iaas/api/projects?$filter=startswith(name, 'ABC')``` - name starts with 'ABC'\\     ```/iaas/api/projects?$filter=substringof('ABC', name``` - name contains 'ABC'\\     ```/iaas/api/projects?$filter=endswith(name, 'ABC')``` - name ends with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20ne%20'example-cloud-account'%20or%20customProperties.isExternal%20eq%20'false'```  6. `$count` -  flag which when specified, regardless of the assigned value, shows the total number of records. If the collection has a filter it shows the number of records matching the filter.\\     ```/iaas/api/cloud-accounts?$count=true```   # noqa: E501

    OpenAPI spec version: 2021-07-15
    Contact: sales@vmware.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ProjectsIdBody(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'description': 'str',
        'administrators': 'list[IaasapiprojectsAdministrators]',
        'members': 'list[IaasapiprojectsAdministrators]',
        'viewers': 'list[IaasapiprojectsAdministrators]',
        'supervisors': 'list[IaasapiprojectsAdministrators]',
        'zone_assignment_configurations': 'list[IaasapiprojectsidzonesZoneAssignmentSpecifications]',
        'constraints': 'dict(str, list[object])',
        'operation_timeout': 'int',
        'machine_naming_template': 'str',
        'shared_resources': 'bool',
        'placement_policy': 'str',
        'custom_properties': 'dict(str, str)'
    }

    attribute_map = {
        'name': 'name',
        'description': 'description',
        'administrators': 'administrators',
        'members': 'members',
        'viewers': 'viewers',
        'supervisors': 'supervisors',
        'zone_assignment_configurations': 'zoneAssignmentConfigurations',
        'constraints': 'constraints',
        'operation_timeout': 'operationTimeout',
        'machine_naming_template': 'machineNamingTemplate',
        'shared_resources': 'sharedResources',
        'placement_policy': 'placementPolicy',
        'custom_properties': 'customProperties'
    }

    def __init__(self, name=None, description=None, administrators=None, members=None, viewers=None, supervisors=None, zone_assignment_configurations=None, constraints=None, operation_timeout=None, machine_naming_template=None, shared_resources=None, placement_policy=None, custom_properties=None):  # noqa: E501
        """ProjectsIdBody - a model defined in Swagger"""  # noqa: E501
        self._name = None
        self._description = None
        self._administrators = None
        self._members = None
        self._viewers = None
        self._supervisors = None
        self._zone_assignment_configurations = None
        self._constraints = None
        self._operation_timeout = None
        self._machine_naming_template = None
        self._shared_resources = None
        self._placement_policy = None
        self._custom_properties = None
        self.discriminator = None
        self.name = name
        if description is not None:
            self.description = description
        if administrators is not None:
            self.administrators = administrators
        if members is not None:
            self.members = members
        if viewers is not None:
            self.viewers = viewers
        if supervisors is not None:
            self.supervisors = supervisors
        if zone_assignment_configurations is not None:
            self.zone_assignment_configurations = zone_assignment_configurations
        if constraints is not None:
            self.constraints = constraints
        if operation_timeout is not None:
            self.operation_timeout = operation_timeout
        if machine_naming_template is not None:
            self.machine_naming_template = machine_naming_template
        if shared_resources is not None:
            self.shared_resources = shared_resources
        if placement_policy is not None:
            self.placement_policy = placement_policy
        if custom_properties is not None:
            self.custom_properties = custom_properties

    @property
    def name(self):
        """Gets the name of this ProjectsIdBody.  # noqa: E501

        A human-friendly name used as an identifier in APIs that support this option.  # noqa: E501

        :return: The name of this ProjectsIdBody.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ProjectsIdBody.

        A human-friendly name used as an identifier in APIs that support this option.  # noqa: E501

        :param name: The name of this ProjectsIdBody.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def description(self):
        """Gets the description of this ProjectsIdBody.  # noqa: E501

        A human-friendly description.  # noqa: E501

        :return: The description of this ProjectsIdBody.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this ProjectsIdBody.

        A human-friendly description.  # noqa: E501

        :param description: The description of this ProjectsIdBody.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def administrators(self):
        """Gets the administrators of this ProjectsIdBody.  # noqa: E501

        List of administrator users associated with the project. Only administrators can manage project's configuration.  # noqa: E501

        :return: The administrators of this ProjectsIdBody.  # noqa: E501
        :rtype: list[IaasapiprojectsAdministrators]
        """
        return self._administrators

    @administrators.setter
    def administrators(self, administrators):
        """Sets the administrators of this ProjectsIdBody.

        List of administrator users associated with the project. Only administrators can manage project's configuration.  # noqa: E501

        :param administrators: The administrators of this ProjectsIdBody.  # noqa: E501
        :type: list[IaasapiprojectsAdministrators]
        """

        self._administrators = administrators

    @property
    def members(self):
        """Gets the members of this ProjectsIdBody.  # noqa: E501

        List of member users associated with the project.   # noqa: E501

        :return: The members of this ProjectsIdBody.  # noqa: E501
        :rtype: list[IaasapiprojectsAdministrators]
        """
        return self._members

    @members.setter
    def members(self, members):
        """Sets the members of this ProjectsIdBody.

        List of member users associated with the project.   # noqa: E501

        :param members: The members of this ProjectsIdBody.  # noqa: E501
        :type: list[IaasapiprojectsAdministrators]
        """

        self._members = members

    @property
    def viewers(self):
        """Gets the viewers of this ProjectsIdBody.  # noqa: E501

        List of viewer users associated with the project.   # noqa: E501

        :return: The viewers of this ProjectsIdBody.  # noqa: E501
        :rtype: list[IaasapiprojectsAdministrators]
        """
        return self._viewers

    @viewers.setter
    def viewers(self, viewers):
        """Sets the viewers of this ProjectsIdBody.

        List of viewer users associated with the project.   # noqa: E501

        :param viewers: The viewers of this ProjectsIdBody.  # noqa: E501
        :type: list[IaasapiprojectsAdministrators]
        """

        self._viewers = viewers

    @property
    def supervisors(self):
        """Gets the supervisors of this ProjectsIdBody.  # noqa: E501

        List of supervisor users associated with the project.   # noqa: E501

        :return: The supervisors of this ProjectsIdBody.  # noqa: E501
        :rtype: list[IaasapiprojectsAdministrators]
        """
        return self._supervisors

    @supervisors.setter
    def supervisors(self, supervisors):
        """Sets the supervisors of this ProjectsIdBody.

        List of supervisor users associated with the project.   # noqa: E501

        :param supervisors: The supervisors of this ProjectsIdBody.  # noqa: E501
        :type: list[IaasapiprojectsAdministrators]
        """

        self._supervisors = supervisors

    @property
    def zone_assignment_configurations(self):
        """Gets the zone_assignment_configurations of this ProjectsIdBody.  # noqa: E501

        List of configurations for zone assignment to a project.  # noqa: E501

        :return: The zone_assignment_configurations of this ProjectsIdBody.  # noqa: E501
        :rtype: list[IaasapiprojectsidzonesZoneAssignmentSpecifications]
        """
        return self._zone_assignment_configurations

    @zone_assignment_configurations.setter
    def zone_assignment_configurations(self, zone_assignment_configurations):
        """Sets the zone_assignment_configurations of this ProjectsIdBody.

        List of configurations for zone assignment to a project.  # noqa: E501

        :param zone_assignment_configurations: The zone_assignment_configurations of this ProjectsIdBody.  # noqa: E501
        :type: list[IaasapiprojectsidzonesZoneAssignmentSpecifications]
        """

        self._zone_assignment_configurations = zone_assignment_configurations

    @property
    def constraints(self):
        """Gets the constraints of this ProjectsIdBody.  # noqa: E501

        List of storage, network and extensibility constraints to be applied when provisioning through this project.  # noqa: E501

        :return: The constraints of this ProjectsIdBody.  # noqa: E501
        :rtype: dict(str, list[object])
        """
        return self._constraints

    @constraints.setter
    def constraints(self, constraints):
        """Sets the constraints of this ProjectsIdBody.

        List of storage, network and extensibility constraints to be applied when provisioning through this project.  # noqa: E501

        :param constraints: The constraints of this ProjectsIdBody.  # noqa: E501
        :type: dict(str, list[object])
        """

        self._constraints = constraints

    @property
    def operation_timeout(self):
        """Gets the operation_timeout of this ProjectsIdBody.  # noqa: E501

        The timeout that should be used for Blueprint operations and Provisioning tasks. The timeout is in seconds  # noqa: E501

        :return: The operation_timeout of this ProjectsIdBody.  # noqa: E501
        :rtype: int
        """
        return self._operation_timeout

    @operation_timeout.setter
    def operation_timeout(self, operation_timeout):
        """Sets the operation_timeout of this ProjectsIdBody.

        The timeout that should be used for Blueprint operations and Provisioning tasks. The timeout is in seconds  # noqa: E501

        :param operation_timeout: The operation_timeout of this ProjectsIdBody.  # noqa: E501
        :type: int
        """

        self._operation_timeout = operation_timeout

    @property
    def machine_naming_template(self):
        """Gets the machine_naming_template of this ProjectsIdBody.  # noqa: E501

        The naming template to be used for machines provisioned in this project  # noqa: E501

        :return: The machine_naming_template of this ProjectsIdBody.  # noqa: E501
        :rtype: str
        """
        return self._machine_naming_template

    @machine_naming_template.setter
    def machine_naming_template(self, machine_naming_template):
        """Sets the machine_naming_template of this ProjectsIdBody.

        The naming template to be used for machines provisioned in this project  # noqa: E501

        :param machine_naming_template: The machine_naming_template of this ProjectsIdBody.  # noqa: E501
        :type: str
        """

        self._machine_naming_template = machine_naming_template

    @property
    def shared_resources(self):
        """Gets the shared_resources of this ProjectsIdBody.  # noqa: E501

        Specifies whether the resources in this projects are shared or not. If not set default will be used.  # noqa: E501

        :return: The shared_resources of this ProjectsIdBody.  # noqa: E501
        :rtype: bool
        """
        return self._shared_resources

    @shared_resources.setter
    def shared_resources(self, shared_resources):
        """Sets the shared_resources of this ProjectsIdBody.

        Specifies whether the resources in this projects are shared or not. If not set default will be used.  # noqa: E501

        :param shared_resources: The shared_resources of this ProjectsIdBody.  # noqa: E501
        :type: bool
        """

        self._shared_resources = shared_resources

    @property
    def placement_policy(self):
        """Gets the placement_policy of this ProjectsIdBody.  # noqa: E501

        Placement policy for the project. Determines how a zone will be selected for provisioning. DEFAULT, SPREAD or SPREAD_MEMORY.  # noqa: E501

        :return: The placement_policy of this ProjectsIdBody.  # noqa: E501
        :rtype: str
        """
        return self._placement_policy

    @placement_policy.setter
    def placement_policy(self, placement_policy):
        """Sets the placement_policy of this ProjectsIdBody.

        Placement policy for the project. Determines how a zone will be selected for provisioning. DEFAULT, SPREAD or SPREAD_MEMORY.  # noqa: E501

        :param placement_policy: The placement_policy of this ProjectsIdBody.  # noqa: E501
        :type: str
        """

        self._placement_policy = placement_policy

    @property
    def custom_properties(self):
        """Gets the custom_properties of this ProjectsIdBody.  # noqa: E501

        The project custom properties which are added to all requests in this project  # noqa: E501

        :return: The custom_properties of this ProjectsIdBody.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._custom_properties

    @custom_properties.setter
    def custom_properties(self, custom_properties):
        """Sets the custom_properties of this ProjectsIdBody.

        The project custom properties which are added to all requests in this project  # noqa: E501

        :param custom_properties: The custom_properties of this ProjectsIdBody.  # noqa: E501
        :type: dict(str, str)
        """

        self._custom_properties = custom_properties

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ProjectsIdBody, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ProjectsIdBody):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
